import { AfterContentInit, ChangeDetectorRef, EventEmitter } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import { PickerController } from '@ionic/angular';
import { Mode, SelectPopoverOption, StyleEventDetail } from '@ionic/core';
import { CityPickerColumn } from './ionic4-city-picker.model';
export declare const CITY_PICKER_VALUE_ACCESSOR: any;
export declare class IonCityPicker implements AfterContentInit, ControlValueAccessor {
    private pickerCtrl;
    private changeDetectorRef;
    private cityIds;
    private inputId;
    labelId: string;
    private cityValue;
    cityText: string;
    addPlaceholderClass: boolean;
    private buttonEl?;
    isExpanded: boolean;
    private isLoadData;
    private provinceCol;
    private cityCol;
    private regionCol;
    private onChange;
    private onTouch;
    /**
     * The value of the city string.
     */
    value: string;
    /**
     * The mode determines which platform styles to use.
     */
    mode: Mode;
    /**
     * The name of the control, which is submitted with the form data.
     */
    name: string;
    /**
     * If `true`, the user cannot interact with the city.
     */
    disabled: boolean;
    /**
     * If `true`, the city appears normal but is not interactive.
     */
    readonly: boolean;
    /**
     * Any additional options that the picker interface can accept.
     * See the [Picker API docs](https://ionicframework.com/docs/api/picker) for the picker options.
     */
    pickerOptions?: SelectPopoverOption;
    /**
     * @input {string} The text to display on the picker's cancel button. Default: `Cancel`.
     */
    cancelText: string;
    /**
     * @input {string} The text to display on the picker's "Done" button. Default: `Done`.
     */
    doneText: string;
    /**
     * @input {CityPickerColumn} city data
     */
    citiesData: CityPickerColumn[];
    /**
     * @input {string} separate
     */
    separator: string;
    /**
     * The text to display when there's no city selected yet.
     * Using lowercase to match the input attribute
     */
    placeholder?: string | null;
    /**
     * @output {any} Emitted when the city selection has changed.
     */
    ionChange: EventEmitter<any>;
    /**
     * @output {any} Emitted when the city selection was cancelled.
     */
    ionCancel: EventEmitter<any>;
    /**
     * Emitted when the styles change.
     * @internal
     */
    ionStyle: EventEmitter<StyleEventDetail>;
    constructor(pickerCtrl: PickerController, changeDetectorRef: ChangeDetectorRef);
    ngAfterContentInit(): void;
    ngAfterContentChecked(): void;
    writeValue(val: any): void;
    registerOnChange(fn: Function): void;
    registerOnTouched(fn: Function): void;
    onClick(ev: UIEvent): void;
    onKeyup(ev: UIEvent): void;
    private open;
    private emitStyle;
    private updateCityValue;
    private generatePickerOptions;
    private convertDuration;
    private generateColumns;
    private valiCity;
    setValue(newData: any): void;
    getValue(): string;
    getText(): string;
    private hasValue;
    private setFocus;
    private divyColumns;
    private updateValue;
    private parseValue;
    private renderValue;
    private hasPlaceholder;
    private hasReadonly;
    private hasDisable;
}
